include     \masm32\include\masm32rt.inc

ParseCmdLine PROTO :DWORD

.data

_format db '%X%X-%X%X',0

.data?

VolumeNameBuffer db 48 dup(?)
buffer db 512 dup(?)

.code

start:


    call    main
    invoke  ExitProcess,0

main PROC uses esi ebx

    mov     esi,OFFSET buffer
    
    invoke  ParseCmdLine,esi
    cmp     eax,2
    je      @f
    ret
@@:
    invoke  GetVolumeInformation,DWORD PTR [esi+4],\
            ADDR VolumeNameBuffer,48,\
            0,0,0,0,0

    invoke  StdOut,ADDR VolumeNameBuffer
    ret   
            
main ENDP


ParseCmdLine PROC uses esi edi ebx buff:DWORD

    invoke  GetCommandLine
    lea     edx,[eax-1]
    xor     eax,eax
    mov     esi,buff
    lea     edi,[esi+256]
    mov     ch,32
    mov     bl,9

scan:

    inc     edx
    mov     cl,BYTE PTR [edx]
    test    cl,cl
    jz      finish
    cmp     cl,32
    je      scan
    cmp     cl,9
    je      scan
    inc     eax
    mov     DWORD PTR [esi],edi
    add     esi,4

restart:

    mov     cl,BYTE PTR [edx]
    test    cl,cl
    jne     @f
    mov     BYTE PTR [edi],cl
    ret
@@:
    cmp     cl,ch
    je      end_of_line
    cmp     cl,bl
    je      end_of_line
    cmp     cl,34
    jne     @f
    xor     ch,32
    xor     bl,9
    jmp     next_char
@@:	
    mov     BYTE PTR [edi],cl
    inc     edi

next_char:

    inc     edx
    jmp     restart

end_of_line:

    mov     BYTE PTR [edi],0
    inc     edi
    jmp     scan	

finish:

    ret

ParseCmdLine ENDP

END start

